// pages/login/login.js
import WxValidate from '../../utils/wxValidate'
const app = getApp()
Page({
    /**
     * 页面的初始数据
     */
    data: {
        // 主体高度
        infoHeight: '',
        frameStyle: { useTop: true, name: '个人信息', leftArrow: true, useBar: false },
        form: {
        },
        // index: 0,
        // 上传图片
        fileList: [],
    },

    afterRead: function (event) {
        const { file } = event.detail;
        const that = this;
        // 当设置 mutiple 为 true 时, file 为数组格式，否则为对象格式app.globalData.fileUrl：
        console.log(file);
        wx.uploadFile({
            url: `${app.globalData.imageUrl}/files/court/elimg/upload`,
            filePath: file.url,
            name: 'file',
            formData: {},
            success: (res) => {
                // console.log(res);
                if (res.statusCode == '200') {
                    let data = [{ name: JSON.parse(res.data).name, url: `${app.globalData.imageUrl}` + JSON.parse(res.data).uri }]
                    // const { fileList = [] } = this.data;
                    // fileList.push({ ...file, url: res.data });
                    that.setData({ fileList: data });
                } else {
                    wx.showToast({ title: `${res.data.errmsg}`, icon: 'fail', duration: 2000 })
                }
            },
        });
    },
    // //选择
    // bindPickerChange: function (e) {
    //     console.log('picker发送选择改变，携带值为', e.detail.value)
    //     this.setData({
    //         index: e.detail.value
    //     })
    // },
    back: function () {
        wx.navigateBack({ url: '/pages/me/index' })
    },
    //验证必填项
    initValidate() {
        const rules = { phone: { required: true, tel: true }, }
        // 验证字段的提示信息，若不传则调用默认的信息
        const messages = { phone: { required: '请输入手机号' }, };
        this.WxValidate = new WxValidate(rules, messages)
    },
    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        // 计算高度
        this.searchHeight();
        // 监听用户是否登录
        this.watchLogin();
        //验证规则函数
        this.initValidate();

    },
    // 监听用户是否登录
    watchLogin: function () {
        const that = this;
        wx.getStorage({
            key: 'token',
            success: res => {
                //数据请求
                wx.request({
                    url: `${app.globalData.publicUrl}/courtAdmin/api/user/${res.data.id}`, //接口地址
                    method: "get",//请求方法
                    data: {},//请求参数
                    header: {},
                    success: res => {
                        console.log(res);
                        that.setData({ form: res.data.data })
                        let icon = res.data.data.icon;
                        this.setData({ fileList: icon })
                    },
                    error: err => {
                        console.log(err);
                    }
                })
            },
            fail: res => {
                wx.redirectTo({ url: '/pages/login/index', })
            }
        })
    },
    //提交
    formSubmit: function (e) {
        const value = e.detail.value;
        if (!this.WxValidate.checkForm(value)) {
            const error = this.WxValidate.errorList[0];
            wx.showToast({ title: `${error.msg}`, icon: 'error', duration: 2000 })
            return false
        } else {
            value.icon = this.data.fileList;
            wx.getStorage({
                key: 'token',
                success: function (res) {
                    wx.request({
                        url: `${app.globalData.publicUrl}/courtAdmin/api/user/${res.data.id}`, //接口地址
                        method: "post",
                        data: value,
                        header: {},
                        success: res => {
                            if (res.data.errcode == 0) {
                                wx.showToast({
                                    title: '保存成功',
                                    icon: 'success',
                                    duration: 2000//延迟两秒
                                })
                            } else {
                                wx.showToast({
                                    title: '保存失败',
                                    icon: 'success',
                                    duration: 2000
                                })
                            }
                        },
                    })
                }
            })
        }
    },
    // 计算高度
    searchHeight: function () {
        let frameStyle = this.data.frameStyle;
        let client = app.globalData.client;
        // 减去状态栏
        let infoHeight = client.windowHeight - (client.statusBarHeight + client.getMenu.height + (client.getMenu.top - client.statusBarHeight) * 2);
        // 是否减去底部菜单
        if (frameStyle.useBar) infoHeight = infoHeight - 50;
        if (infoHeight) this.setData({ infoHeight: infoHeight })
    },

    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {

    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage: function () {

    }
})